import { BigNumberString, DecimalString, HexString32 } from "@snickerdoodlelabs/objects";
import { IBigNumberUtils } from "../interfaces/index.js";
export declare class BigNumberUtils implements IBigNumberUtils {
    constructor();
    multiply(bn: bigint | BigNumberString, number: number, decimals?: number): bigint;
    divide(bn: bigint | BigNumberString, number: number, decimals?: number): bigint;
    DSToBN(decimalString: DecimalString, decimals?: number): bigint;
    DSToBNS(decimalString: DecimalString, decimals?: number): BigNumberString;
    BNToBNS(bigint: bigint): BigNumberString;
    BNToDS(bigNumber: bigint, decimals?: number): DecimalString;
    BNSToBN(bigNumberString: BigNumberString): bigint;
    BNSToDS(bigNumberString: BigNumberString, decimals?: number): DecimalString;
    BNStoHexString32(bigNumberString: BigNumberString): HexString32;
    BNStoHexString32NoPrefix(bigNumberString: BigNumberString): HexString32;
    HexString32NoPrefixToBNS(hexString: HexString32): BigNumberString;
    /**
     * This method returns true if the bigNumberString is a
     * @param bigNumberString
     * @returns true if bigNumberString is a valid bigint
     */
    validateBNS(bigNumberString: string): boolean;
}
//# sourceMappingURL=BigNumberUtils.d.ts.map