var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { BigNumberString, DecimalString, HexString32, } from "@snickerdoodlelabs/objects";
import { ethers } from "ethers";
import { injectable } from "inversify";
let BigNumberUtils = class BigNumberUtils {
    constructor() { }
    multiply(bn, number, decimals = 18) {
        const bnForSure = BigInt(bn);
        const multiplierBN = ethers.parseUnits(number.toString(), decimals);
        const oneBN = ethers.parseUnits("1", decimals);
        return (bnForSure * multiplierBN) / oneBN;
    }
    divide(bn, number, decimals = 18) {
        const bnForSure = BigInt(bn);
        const divisorBN = ethers.parseUnits(number.toString(), decimals);
        const oneBN = ethers.parseUnits("1", decimals);
        return (bnForSure * oneBN) / divisorBN;
    }
    /* Conversion from decimal string to big number and big number string */
    DSToBN(decimalString, decimals = 18) {
        return ethers.parseUnits(decimalString, decimals);
    }
    DSToBNS(decimalString, decimals) {
        return BigNumberString(ethers.parseUnits(decimalString, decimals).toString());
    }
    /* End region of decimal string conversions */
    /* Conversion from big number to big number string and decimal string */
    BNToBNS(bigint) {
        return BigNumberString(BigInt(bigint).toString());
    }
    BNToDS(bigNumber, decimals = 18) {
        return DecimalString(ethers.formatUnits(bigNumber, decimals || 18));
    }
    /* End region of big number conversions */
    /* Conversion from big number string to big number and decimal string */
    BNSToBN(bigNumberString) {
        return BigInt(bigNumberString);
    }
    BNSToDS(bigNumberString, decimals = 18) {
        const valueBigNumber = BigInt(bigNumberString);
        return DecimalString(ethers.formatUnits(valueBigNumber, decimals || 18));
    }
    BNStoHexString32(bigNumberString) {
        return HexString32(ethers.toBeHex(this.BNSToBN(bigNumberString)));
    }
    BNStoHexString32NoPrefix(bigNumberString) {
        return HexString32(ethers.toBeHex(this.BNSToBN(bigNumberString)).substring(2));
    }
    HexString32NoPrefixToBNS(hexString) {
        return BigNumberString(BigInt(`0x${hexString}`).toString());
    }
    /* End region of big number string conversions */
    /**
     * This method returns true if the bigNumberString is a
     * @param bigNumberString
     * @returns true if bigNumberString is a valid bigint
     */
    validateBNS(bigNumberString) {
        try {
            BigInt(bigNumberString);
            return true;
        }
        catch (e) {
            return false;
        }
    }
};
BigNumberUtils = __decorate([
    injectable(),
    __metadata("design:paramtypes", [])
], BigNumberUtils);
export { BigNumberUtils };
//# sourceMappingURL=BigNumberUtils.js.map